Summary: The DENX Simple Embedded Linux Framework
Name: SELF
Version: 1.0
Release: 12
License: GPL
Group: Applications/System
Source0: SELF.tar.bz2
Patch1: busybox-ctrlc.patch
Patch2: SELF_arm.patch
Patch3: SELF_uclibc.patch
BuildRoot: %{_tmppath}/%{name}-root


%description
The SELF (Simple Embedded Linux Framework) provides a simple framework
with many useful tools in a resource-efficient way which allows you
just to "drop in" your application code. "telnet" and "ftp" access to
the target are included.

%prep

%setup -q -n SELF
%patch1 -p1
if [ x$UCLIBC != x ]; then
%patch2 -p1
%patch3 -p1
else
%ifarch arm
%patch2 -p1
%endif
true
fi

%build

%install
: ${INITRD_SIZE:=5120}

# Make sure build directory is empty
rm -fr $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT

for dir in \
        images  \
        ramdisk \
        ramdisk/{bin,dev,etc,ftp,home,lib,proc,sbin,tmp,usr,usr/sbin} \
        ramdisk/{var,var/log,var/run}
do
        mkdir $RPM_BUILD_ROOT/$dir
done

WORK=`pwd`

# Copy /etc files from the SELF tarball
cpio -Bpdum $RPM_BUILD_ROOT/ramdisk < $WORK/etc-files.list

# Copy Binaries and Libraries from the target environment
( cd $RUNTIME_PREFIX/%{_targetpath} ;
  cpio -Bpdum $RPM_BUILD_ROOT/ramdisk <$WORK/files.list         || exit 1
%ifarch ppc64
  sed -e "s|lib/|lib64/|g" -e "s|ld.so|ld64.so|g" $WORK/libraries.list > \
  $WORK/libraries64.list
  tar -c -v -f /dev/null -T $WORK/libraries64.list | \
  cpio -Bpdum $RPM_BUILD_ROOT/ramdisk || exit 1
%else
  tar -c -v -f /dev/null -T $WORK/libraries.list | \
  cpio -Bpdum $RPM_BUILD_ROOT/ramdisk  || exit 1
%endif
)

# Copy (dummy) application
cp $WORK/application.sh $RPM_BUILD_ROOT/ramdisk/bin/application

# Strip Libraries
# Install BusyBox and create links
( cd $RPM_BUILD_ROOT/ramdisk/ ;
  find ./%{_lib} -name  *.[0-9].so -exec %{_targetarch}-linux-strip \
     --remove-section=.note --remove-section=.comment {} \;
  cp $RUNTIME_PREFIX/%{_targetpath}/sbin/busybox ./bin/busybox
  for lnk in `sed -e 's!/usr!!' $RUNTIME_PREFIX/%{_targetpath}/usr/lib/busybox/busybox.links` ; do
        ln -s ../bin/busybox ./$lnk
  done
)

## ls -lR $RPM_BUILD_ROOT/ramdisk/

# Make devices
( cd $RPM_BUILD_ROOT/ramdisk/dev ;
  echo "/dev d 755 0 0 - - - - -" > $RPM_BUILD_ROOT/devices.txt
  while read cmd a1 a2 a3 a4 ; do
        # Skip comments
        expr "$cmd" : '#*' >/dev/null && continue
        # A tiny bit of security:
        # "only" execute mknod and "chmod" commands as root
        case "$cmd" in
	mknod) echo -e "/dev/$a1 $a2 600 0 0 $a3 $a4 0 0 -" >> $RPM_BUILD_ROOT/devices.txt ;;
	chmod) ;;
        *)              $cmd $a1 $a2 $a3 $a4               ;;
        esac
  done <$WORK/SELF_MAKEDEV
)

genext2fs \
	-d $RPM_BUILD_ROOT/ramdisk \
	-b $INITRD_SIZE \
	-D $RPM_BUILD_ROOT/devices.txt -m 0 -N 600 \
	$RPM_BUILD_ROOT/images/ramdisk_image

gzip -9 $RPM_BUILD_ROOT/images/ramdisk_image
%ifarch ppc64
mkimage -A ppc -O Linux -T ramdisk -C gzip \
%else
mkimage -A %{_arch} -O Linux -T ramdisk -C gzip \
%endif
        -n 'Simple Embedded Linux Framework' \
        -d $RPM_BUILD_ROOT/images/ramdisk_image.gz \
        $RPM_BUILD_ROOT/images/uRamdisk
rm -rf $RPM_BUILD_ROOT/devices.txt
rm -rf $RPM_BUILD_ROOT/ramdisk

%clean
rm -rf $RPM_BUILD_ROOT

%files
%dir /images
/images/uRamdisk
/images/ramdisk_image.gz
